#!/usr/bin/perl
#	@(#) $Header: /xenu/nick/CVS-TREE/Src/Math-Trainer/index.cgi,v 1.3 2002/11/10 12:28:35 nick Exp $
#	Copyright (C) 2002, Nick Andrew <nick@nick-andrew.net>
#	This program is distributed under the terms of the GNU
#	General Public License (see http://www.gnu.org/licenses/gpl.html)

use CGI ();

my $cgi = new CGI();

my $problem = $cgi->param('problem');
my $solution = $cgi->param('solution');
my $answer = $cgi->param('answer');

my $correct_count = $cgi->cookie('correct_count') || 0;
my $problem_count = $cgi->cookie('problem_count') || 0;

# Massage answer
$answer =~ s/\D//g;

if ($problem && $answer ne '') {
	if ($solution == $answer) {
		$correct_count++;
	}
	$problem_count++;
}


print $cgi->header(
	-type => 'text/html',
	-expires => 'now',
	-cookie => [
		$cgi->cookie(-name => 'correct_count', -value => $correct_count, -expires=>'+1h'),
		$cgi->cookie(-name => 'problem_count', -value => $problem_count, -expires=>'+1h'),
	],
);


print <<EOF;
<html>
<head>
<title>Math practice</title>
</head>
<body>
<font face="courier" size="26">
EOF

if ($problem && $answer ne '') {
	my $colour;
	my $response;
	my $image;

	if ($answer == $solution) {
		$colour = "#c0ffc0";
		$response = "Correct! $problem $solution";
		my @images = <Right/*.jpg>;
		my $pick = $images[int(rand(scalar @images))];
		$image = "<img src=\"$pick\">";
	} else {
		$colour = "#ffc0c0";
		$response = "Wrong, $problem $solution, not $answer";
		$image = "&nbsp;";
	}

	print <<EOF;
<table bgcolor="$colour" border="0" cellpadding="10" cellspacing="0">
<tr>
<td>$response
</td>
</tr>
<tr>
<td>$image</td>
</tr>
</table>
EOF
}

if ($problem_count) {
	print "You have $correct_count out of $problem_count right!<br>\n";
}

# Now print a form for the next one

my $op1 = int(rand(50));
my $op2 = int(rand(4));
my $sum = $op1 + $op2;
$problem = "$op1 + $op2 =";

print <<EOF;
<form method="POST" action="index.cgi">
<input type="hidden" name="problem" value="$problem">
<input type="hidden" name="solution" value="$sum">
$problem <input name="answer" size="6" maxlength="3">
</font>
</form>
</body>
</html>
EOF

exit(0);

